;
;       g e t c u r s p o s
;
;   Routine to get the x/y coordinate of the cursor in a window.
;
;   Equivalent to C routine:
;
;     int _getcurspos(chanid_t chanid);
;
;   Returns:
;       -ve     Error occured, or cursor invisible 
;       >=0     Cursor position x (high word), y (low word)
;
;   AMENDMENT HISTORY
;   ~~~~~~~~~~~~~~~~~

    .text
    .even
    .globl __getcurspos


IOW.XTOP equ $09

SD_XPOS  equ $22

SAVEREG  equ 24+4

getcurspos:
    move.l  SD_XPOS(a0),d1
    moveq   #0,d0
    rts

__getcurspos:
    movem.l d2-d4/a2-a4,-(a7)

    moveq.l #IOW.XTOP,d0
    move.l  0+SAVEREG(a7),a0
    lea     getcurspos(pc),a2
    moveq.l #-1,d3
    trap    #3
    tst.l   d0                      ; call OK ?
    bne     qq                      ; ... NO, return error code
    move.l  d1,d0                   ; ... YES, set cursor state as return value
qq:
    movem.l (a7)+,d2-d4/a2-a4
    rts
