; C68 Sampled Sound Interface by Marcel Kilgus

        .text
        .even

        .globl _sss_check
        .globl _sss_addm
        .globl _sss_setm
        .globl _sss_kill
        .globl _sss_sample

; void *sss_check(void)
par.check equ   8
_sss_check:
        movem.l a2-a3,-(a7)
        moveq   #0,d0
        move.l  $70,a3                  ; Interrupt level 4
        move.l  -(a3),a2                ; Vectors
;        cmp.l   #'SSSS',-(a3)           ; System available?
        cmp.l   #$53535353,-(a3)
        bne     check_exit
        move.l  a3,d0
check_exit:
        movem.l (a7)+,a2-a3
        rts

; void sss_setm(void *sss, void **start, **end)
par.setm equ    20+4
_sss_setm:
        movem.l a0-a3/d7,-(a7)
        move.l  0+par.setm(a7),a3
        move.l  4(a3),a0                ; Vectors

        move    sr,d7
        trap    #0
        jsr     $08(a0)                 ; sss_setm
        move    d7,sr

        move.l  4+par.addm(a7),a0
        move.l  a1,(a0)
        move.l  8+par.addm(a7),a0
        move.l  a2,(a0)

        movem.l (a7)+,a0-a3/d7
        rts

; void sss_addm(void *sss, void *next)
par.addm equ    20+4
_sss_addm:
        movem.l a0-a3/d7,-(a7)
        move.l  0+par.addm(a7),a3
        move.l  4(a3),a0
        move.l  4+par.setm(a7),a1       ; Next free byte

        move    sr,d7
        trap    #0
        jsr     $0c(a0)                 ; sss_addm
        move    d7,sr

        movem.l (a7)+,a0-a3/d7
        rts

; void sss_kill(void *sss)
par.kill equ    12+4
_sss_kill:
        movem.l a2-a3/d7,-(a7)
        move.l  0+par.kill(a7),a3
        move.l  4(a3),a2                ; Vectors

        move    sr,d7
        trap    #0
        jsr     $10(a2)                 ; sss_kill
        move    d7,sr

        movem.l (a7)+,a2-a3/d7
        rts

; unsigned int sss_sample(void *sss)
par.sample equ  12+4
_sss_sample:
        movem.l a2-a3/d7,-(a7)
        move.l  0+par.sample(a7),a3
        move.l  4(a3),a2                ; Vectors

        move    sr,d7
        trap    #0
        jsr     $14(a2)                 ; sss_sample
        move    d7,sr

        movem.l (a7)+,a2-a3/d7
        rts
